#include <stdio.h>
#include <string.h>

typedef struct _PT { short x, y; } PT;

//int leftMost[100], rightMost[100], bottomMost[100];
PT lq[10000], rq[10000], bq[10000];
int nl, nr, nb;
int kw, kh, lw, lh; // key, lock width, height
int x, y, x1, curDepth, ok;
char lock[10100][1000];
int reach[1000];

int testLeft(int x0, int y0)
{
	PT *pt = lq;
	for (int i = 0; i < nl; i++, pt++)
	{
		int X = x0 + pt->x, Y = y0 + pt->y;
		if (Y >= 0) if (lock[Y][X]) return 0;
	}
	return 1;
}

int testRight(int x0, int y0)
{
	PT *pt = rq;
	for (int i = 0; i < nr; i++, pt++)
	{
		int X = x0 + pt->x, Y = y0 + pt->y;
		if (Y >= 0) if (lock[Y][X]) return 0;
	}
	return 1;
}

int testBottom(int x0, int y0)
{
	PT *pt = bq;
	for (int i = 0; i < nb; i++, pt++)
	{
		int X = x0 + pt->x, Y = y0 + pt->y;
		if (Y >= 0) if (lock[Y][X]) return 0;
	}
	return 1;
}

/*
int testLeft(int x0, int y0)
{
	for (int yy = 0; yy < kh; yy++)
	{
		int i = leftMost[yy];
		if (i < kw) if (y0 + yy >= 0)
			if (lock[y0 + yy][x0 + i]) return 0;
	}
	return 1;
}

int testRight(int x0, int y0)
{
	for (int yy = 0; yy < kh; yy++)
	{
		int i = rightMost[yy];
		if (i >= 0) if (y0 + yy >= 0)
			if (lock[y0 + yy][x0 + i]) return 0;
	}
	return 1;
}

int testBottom(int x0, int y0)
{
	for (int xx = 0; xx < kw; xx++)
	{
		int i = bottomMost[xx];
		if (i >= 0) if (y0 + i >= 0)
			if (lock[y0 + i][x0 + xx]) return 0;
	}
	return 1;
}
*/

int main()
{
	int nCases; char line[1024], oldLine[1024];
	gets(line); sscanf(line, "%d", &nCases);
	while (nCases-- > 0)
	{
		gets(line); sscanf(line, "%d %d", &kh, &kw);
		/*
		for (x = 0; x < kw; x++) bottomMost[x] = -1;
		for (y = 0; y < kh; y++)
		{
			leftMost[y] = kw; rightMost[y] = -1;
			gets(line);
			for (x = 0; x < kw; x++) if (line[x] == '#')
			  { if (leftMost[y] > x) leftMost[y] = x;
			    rightMost[y] = x; bottomMost[x] = y; }
		}
		*/
		nl = 0; nr = 0; nb = 0; memset(oldLine, '.', kw);
		for (y = 0; y < kh; y++)
		{
			gets(line);
			for (x = 0; x < kw; x++) if (line[x] == '#')
			{ 
			  if (x == 0 || line[x - 1] == '.') 
			  	{ lq[nl].x = x; lq[nl].y = y; nl++; }
			  if (x == kw - 1 || line[x + 1] == '.') 
			  	{ rq[nr].x = x; rq[nr].y = y; nr++; }
			} 
			else if (oldLine[x] == '#')
				{ bq[nb].x = x; bq[nb].y = y - 1; nb++; }
			memcpy(oldLine, line, kw);
		}
		for (x = 0; x < kw; x++) if (oldLine[x] == '#')
			{ bq[nb].x = x; bq[nb].y = kh - 1; nb++; }
			
		/*
		for (int I = 0; I < nr; I++) printf("<%d, %d> ",
			rq[I].x, rq[I].y); printf("\n");
		*/
		
		/*
		printf("LM-RM: "); for (y = 0; y < kh; y++) 
			printf("%d-%d ", leftMost[y], rightMost[y]);
		printf("\nBM: "); for (x = 0; x < kw; x++)
			printf("%d ", bottomMost[x]); printf("\n");
		*/
		
		gets(line); sscanf(line, "%d %d", &lh, &lw);
		for (y = 0; y < lh; y++)
		{
			memset(&(lock[y][0]), 0, lw);
			gets(line);
			for (x = 0; x < lw; x++) if (line[x] == '#') 
				lock[y][x] = 1;
		}
		for (y = lh; y < lh + kh; y++)
			memset(&(lock[y][0]), 0, lw);
		curDepth = 0;
		for (x = 0; x < lw - kw + 1; x++) reach[x] = 1;
		while (curDepth < lh + kh)
		{
			/*
			printf("Moving from depth %d: ", curDepth);
			for (x = 0; x < lw - kw + 1; x++) printf("%d ", reach[x]);
			printf("\n");
			*/
			int anyReach = 0;
			for (x = 0; x < lw - kw + 1; x++) if (reach[x])
			{
			  ok = testBottom(x, curDepth + 1 - kh);
				reach[x] = ok; if (! ok) continue; anyReach = 1;
			}
			if (! anyReach) break;
			curDepth++;
			/*
			printf("Moving down to depth %d: ", curDepth);
			for (x = 0; x < lw - kw + 1; x++) printf("%d ", reach[x]);
			printf("\n");
			*/
			for (x = 0; x < lw - kw + 1; x++) if (reach[x])
			{
				for (x1 = x - 1; x1 >= 0; x1--)
				{
					if (reach[x1]) break; ok = testLeft(x1, curDepth - kh);
					if (! ok) break; reach[x1] = 1; 
				}
				for (x1 = x + 1; x1 <= lw - kw + 1; x1++)
				{
					if (reach[x1]) break; ok = testRight(x1, curDepth - kh);
					if (! ok) break; reach[x1] = 1; 
				}
			}
		}
		if (curDepth >= lh + kh) printf("The key can fall through.\n");
		else printf("The key falls to depth %d.\n", curDepth);
	}
	return 0;
}