
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

int delta[26];
char got[26][26];
char ok[26];
char gotc[26];

void recurse( int c )
{
  ok[c] = 1;
  for( int n = 0; n < 26; n++ )
    if( !ok[n] && got[c][n] )
      recurse( n );
}

int main()
{
  int C = 0;
  scanf( "%d", &C );
  for( int c = 0; c < C; c++ )
  {
    int N = 0;
    scanf( "%d\n", &N );
    memset( delta, 0, sizeof(delta) );
    memset( got, 0, sizeof(got) );
    memset( gotc, 0, sizeof(gotc) );
    int n;
    for( n = 0; n < N; n++ )
    {
      char line[1010];
      gets( line );
      int l = strlen(line);
      int c1 = line[0]-'a';
      int c2 = line[l-1]-'a';
      delta[c1]++;
      delta[c2]--;
      got[c1][c2] = 1;
      gotc[c1] = 1;
    }
    int bad = 0;
    int ins = 0;
    int outs = 0;
    int in = 0;
    for( n = 0; n < 26; n++ )
    {
      if( delta[n] )
      {
        if( delta[n] == 1 )
        {
          ins++;
          in = n;
        }
        else
        if( delta[n] == -1 )
          outs++;
        else
          bad++;
      }
    }
    if( ins != outs )
      bad = 1;
    if( ins > 1 || outs > 1 )
      bad = 1;
    if( !bad )
    {
      memset( ok, 0, sizeof(ok) );
      recurse( in );
      for( n = 0; n < 26; n++ )
        if( gotc[n] && !ok[n] )
          bad = 1;
    }
    if( bad )
      printf( "The door cannot be opened.\n" );
    else
      printf( "Ordering is possible.\n" );
  }

  return 0;
}